unit hiBASS_StreamCreateMem;

interface

uses Kol,Share,Debug,BASS;

type
  THiBASS_StreamCreateMem = class(TDebug)
   private
    FHandle:HSTREAM;
    FSync:HSYNC;
   public    
    _prop_Flags:integer;
    _prop_Name:string;

    _data_Memory:THI_Event;
    _data_FLength:THI_Event;
    _event_onCreate:THI_Event;
    _event_onEndPlay:THI_Event;
    _event_onError:THI_Event;

    procedure _work_doCreate(var _Data:TData; Index:word);
    procedure _work_doDestroy(var _Data:TData; Index:word);
    function getInterfaceBassHandle:pointer;
  end;

implementation

function THiBASS_StreamCreateMem.getInterfaceBassHandle:pointer;
begin
   Result := @FHandle;
end;

procedure SyncProc(handle:HSYNC; channel:DWORD; data:DWORD; user:pointer); stdcall;
begin
   _hi_onEvent(THiBASS_StreamCreateMem(user)._event_onEndPlay);
end;

procedure THiBASS_StreamCreateMem._work_doCreate;
var Fm:Pointer;
FLength:integer;
begin         
   Fm := Pointer(ReadInteger(_Data,_data_Memory));
   FLength:= ToIntegerEvent(_data_FLength); 
   if FHandle <> 0 then
     begin
       BASS_ChannelRemoveSync(FHandle, FSync);
       BASS_StreamFree(FHandle);
     end;
   
   FHandle := BASS_StreamCreateFile(TRUE, Fm, 0, FLength, _prop_Flags);
   if FHandle = 0 then
     _hi_onEvent(_event_onError, BASS_ErrorGetCode())
   else 
    begin
      FSync := BASS_ChannelSetSync(FHandle, BASS_SYNC_MIXTIME or BASS_SYNC_END, 0, SyncProc, self);
      _hi_onEvent(_event_onCreate);
    end;  
end;

procedure THiBASS_StreamCreateMem._work_doDestroy;
begin
  BASS_StreamFree(FHandle);
  FHandle := 0;
end;

end.
